WebApplication/Models/ErrorViewModel.cs
using System;

namespace WebApplication.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

WebApplication/Models/WeatherData.cs
using Newtonsoft.Json;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace WebApplication.Models
{
    public class WeatherData
    {

        [JsonProperty("name")]

        public string Title { get; set; }

        [JsonProperty("coord")]
        public Coord Coord { get; set; }

        [JsonProperty("weather")]
        public Weather[] Weather { get; set; }

        [JsonProperty("base")]
        public string Base { get; set; }

        [JsonProperty("main")]
        public Main Main { get; set; }

        [JsonProperty("visibility")]
        public long Visibility { get; set; }

        [JsonProperty("wind")]
        public Wind Wind { get; set; }

        [JsonProperty("clouds")]
        public Clouds Clouds { get; set; }

        [JsonProperty("dt")]
        public long Dt { get; set; }

        [JsonProperty("sys")]
        public Sys Sys { get; set; }

        [JsonProperty("id")]
        public long WeatherDetails { get; set; }

        [JsonProperty("cod")]
        public long Cod { get; set; }
    }


    public class Clouds
    {

        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public int ID { get; set; }

        [JsonProperty("all")]
        public long All { get; set; }
    }

    public class Coord
    {
        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public int ID { get; set; }

        [JsonProperty("lon")]
        public double Lon { get; set; }

        [JsonProperty("lat")]
        public double Lat { get; set; }
    }

    public class Main
    {
        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public int ID { get; set; }

        [JsonProperty("temp")]
        public double Temperature { get; set; }

        [JsonProperty("pressure")]
        public long Pressure { get; set; }

        [JsonProperty("humidity")]
        public long Humidity { get; set; }

        [JsonProperty("temp_min")]
        public double TempMin { get; set; }

        [JsonProperty("temp_max")]
        public double TempMax { get; set; }

        [JsonProperty("feels_like")]
        public double Percepita { get; set; }
    }

    public class Sys
    {
        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public int ID { get; set; }
        [JsonProperty("type")]
        public long Type { get; set; }

        [JsonProperty("id")]
        public long weatherinformation { get; set; }

        [JsonProperty("message")]
        public double Message { get; set; }

        [JsonProperty("country")]
        public string Country { get; set; }

        [JsonProperty("sunrise")]
        public long Sunrise { get; set; }

        [JsonProperty("sunset")]
        public long Sunset { get; set; }

    }

    public class Weather

    {
        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public int ID { get; set; }

        [JsonProperty("id")]
        public long WeatherDetails { get; set; }

        [JsonProperty("main")]
        public string Visibility { get; set; }

        [JsonProperty("description")]
        public string Description { get; set; }

        [JsonProperty("icon")]
        public string Icon { get; set; }
    }

    public class Wind
    {
        [Key]
        [DatabaseGeneratedAttribute(DatabaseGeneratedOption.Identity)]
        public int ID { get; set; }

        [JsonProperty("speed")]
        public double Speed { get; set; }

        [JsonProperty("deg")]
        public long Deg { get; set; }
    }
}

WebApplication/Controllers/EmployeeController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using WebApplication.Models;

namespace WebApplication.Controllers
{
    public class EmployeeController : Controller
    {
        private readonly EmployeeContext _context;
        public EmployeeController(EmployeeContext context)
        {
            _context = context;
        }
        public ActionResult Index()
        {
            return View("EmployeeCreate");
        }
        
        public ActionResult Display(Employee model)
        {
            var emp = _context.Employee.ToList();
            if (emp != null)
            {
                Console.WriteLine(emp);
            }
            return View("Listof_Employees",emp);
        }
        [HttpPost]
        public ActionResult SaveRecord(Employee model)
        {
            try
            {
                Employee emp = new Employee();
                emp.EmailId = model.EmailId;
                emp.FirstName = model.FirstName;
                emp.Lastname = model.Lastname;
                emp.city = model.city;
                emp.country = model.country;
                emp.telephone = model.telephone;
                emp.role = model.role;
                emp.address_location = model.address_location;
                emp.password = model.password;
                _context.Add(emp);
                _context.SaveChanges();
            }catch(Exception e)
            {
                Console.WriteLine("Duplicate Data was found");

            }
                return RedirectToAction("Index");
        }
    }
}

WebApplication/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using WebApplication.Models;
using System.Diagnostics;
using WebApplication.Services;
using MimeKit;
using MailKit.Net.Smtp;
using System.Linq;

namespace WebApplication.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        public RestService _rs { get; set; }
        private readonly EmployeeContext _context;
        public HomeController(ILogger<HomeController> logger, EmployeeContext context)
        {
            _logger = logger;
            _context = context;
            _rs = new RestService(_context);
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
   
        public IActionResult WeatherData(string id)
        {
            string weatherapiData = "https://api.openweathermap.org/data/2.5/weather?q=+" + id + "&units=metric&appid=7b415af837daa9f56ea28425c81f0966";
            WeatherData results = _rs.GetWeatherData(weatherapiData).Result;
       
            return View(results);
        }
    }
}

WebApplication/Views/Employee/EmployeeCreate.cshtml
@model WebApplication.Models.Employee

@{
    ViewData["Title"] = "Enter Employee Details";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>View</h1>

<h4>Employee</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="SaveRecord">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="EmailId" class="control-label"></label>
                <input asp-for="EmailId" class="form-control" />
                <span asp-validation-for="EmailId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="FirstName" class="control-label"></label>
                <input asp-for="FirstName" class="form-control" />
                <span asp-validation-for="FirstName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Lastname" class="control-label"></label>
                <input asp-for="Lastname" class="form-control" />
                <span asp-validation-for="Lastname" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="city" class="control-label"></label>
                <input asp-for="city" class="form-control" />
                <span asp-validation-for="city" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="country" class="control-label"></label>
                <input asp-for="country" class="form-control" />
                <span asp-validation-for="country" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="telephone" class="control-label"></label>
                <input asp-for="telephone" class="form-control" />
                <span asp-validation-for="telephone" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="role" class="control-label"></label>
                <input asp-for="role" class="form-control" />
                <span asp-validation-for="role" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="address_location" class="control-label"></label>
                <input asp-for="address_location" class="form-control" />
                <span asp-validation-for="address_location" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="password" class="control-label"></label>
                <input type = "password" asp-for="password" class="form-control" />
                <span asp-validation-for="password" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

WebApplication/Views/Employee/Listof_Employees.cshtml
@model IEnumerable<WebApplication.Models.Employee>

@{
    ViewData["Title"] = "Listof_Employees";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Listof_Employees</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.EmailId)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.FirstName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Lastname)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.city)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.country)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.role)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.address_location)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.password)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
             <td>
                @Html.DisplayFor(modelItem => item.EmailId)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.FirstName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Lastname)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.city)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.country)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.role)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.address_location)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.password)
            </td>
            <td>
                @Html.ActionLink("Edit", "Edit", new { /* id=item.PrimaryKey */ }) |
                @Html.ActionLink("Details", "Details", new { /* id=item.PrimaryKey */ }) |
                @Html.ActionLink("Delete", "Delete", new { /* id=item.PrimaryKey */ })
            </td>
        </tr>
}
    </tbody>
</table>

WebApplication/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome to the WeatherApplication!</h1>
    <br />
    <label for="usr">Insert your City</label>
    <input type="text" class="form-control" id="usr" text-center>
    <br />
    <input type="button"class="btn btn-info" id="WeatherSearch" value="Check the weather!" />
</div>


@section Scripts {
    <script type="text/javascript">
        $("#WeatherSearch").click(function () {
            var txtVal = $("#usr").val();
            window.location = "@Url.Action("WeatherData","Home")" +
                              "/" + txtVal;
        });
    </script>
}

WebApplication/Views/Home/WeatherData.cshtml
@model WeatherData
@{ Layout = "_Layout"; ViewBag.Title = "Weather Application";}

@try
{
    <h2>Weather Info @Model.Title</h2>
    string tipoMeteo = "";
    switch (Model.Weather[0].Visibility.ToString())
    {
        case "Rain": tipoMeteo = "Rainy 🌧"; break;
        case "Clear": tipoMeteo = "Sunny! ☀"; break;
        case "Clouds": tipoMeteo = "Cloudy ⛅"; break;
    }
    <table class="table table-sm table-striped table-bordered m-2">
        <thead><tr><th>Weather</th><th>Temperature</th><th>Humidity</th><th>Perceived Temperature</th><th>Wind</th></tr></thead>
        <tbody>

            <tr>
                <td>@tipoMeteo </td>
                <td>@Model.Main.Temperature °C</td>
                <td>@Model.Main.Humidity %</td>
                <td>@Model.Main.Percepita °C</td>
                <td>@Model.Wind.Speed Nodi</td>
            </tr>


        </tbody>
    </table>
    <br />
    <a asp-action="" class="btn btn-sm btn-primary">Search Again!</a>
    <br />
    @switch (Model.Weather[0].Visibility.ToString())
    {
        case "Clear":
            <img src="~/Images/sunny.jpg" height="400" width="700">
            ; break;
        case "Clouds":
            <img src="~/Images/cloudy.jpg" height="400" width="700">
            ; break;
        case "Rain":
                <img src="~/Images/rainy.jpg" height="400" width="700">
                ; break;
        }
}
catch
{

    <h1> City Entered Cannot be found Error 404</h1>

    <br />
    <a asp-action="" class="btn btn-sm btn-primary">Search Again!</a>

}

WebApplication/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Weather Application</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">WebApplication</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Employee" asp-action="Index"> EmployeeCreate</a>
                        </li> 
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Employee" asp-action="Display">Display Employee</a>
                        </li
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - WeatherApplication - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>